#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define ABS(X) (((X) > 0) ? (X) : (-X))
#define MAX 20
#define NUM 20

#define ALLOCATE                                   \
   do {                                            \
        lower=calloc(k,sizeof(double));            \
        upper=calloc(k,sizeof(double));            \
        alpha=calloc(k,sizeof(double));            \
        beta=(double**)malloc(k*sizeof(double*));  \
        for(i=0;i<k;i++)                           \
           beta[i]=calloc(k,sizeof(double));       \
        for(i=0;i<MAX;i++)                         \
        {                                          \
           seeds[i]=(int**)malloc(k*sizeof(int*)); \
           for(j=0;j<k;j++)                        \
              seeds[i][j]=calloc(2,sizeof(int));   \
        }                                          \
       } while(0);


double accept_reject(double alpha, double beta, double c, double peak, 
                     double y, double r, int seed);
int check_coalescence(double *lower, double *upper, int k);
double comp_beta(int index, double **beta, double *state, int k);
void comp_seeds(int ***seeds,int k);
double draw_unif(double gamma, double alpha, double beta, double y, 
                  int reseed, int seed);
double draw_y(double alpha, double beta, double u, double x, double peak, 
              double c);
double find_limit(double alpha, double beta, double x, double y, double c, 
                  double peak);
double gamma_dens(double alpha, double beta, double x);
void initialize(double *lower, double *upper, double *alpha, double **beta, 
                int **seed, int k);
double shift_patch(double u,double l1, double r1, double alpha, double beta,
                   double peak,double s,double c, double y, double inc, 
                   int *flag);
double sim_gamma(double alpha,double beta);
double slice_gamma1(double alpha, double beta, int *seed);
void slice_gamma2(double alpha, double beta, double beta_l, double beta_u, 
                  double *g_l, double *g_u, int *seed);
void update_chain(double *lower, double *upper, double *alpha, double **beta, 
                  double b, int **seeds, int k);







